variables:
  MAVEN_OPTS: -Dmaven.repo.local=.m2/repository
  DOCKER_DRIVER: overlay
  SPRING_PROFILES_ACTIVE: gitlab-ci

stages:
  - build
  - docker
  - contract-tests

maven-build:
  image: maven:3-jdk-8
  stage: build
  script: "mvn clean package -B"
  artifacts:
    paths:
      - target/*.jar
      
docker:
  image: docker:latest
  stage: docker
  services:
    - docker:dind
  before_script:
    - echo $CI_BUILD_TOKEN | docker login -u "$CI_REGISTRY_USER" --password-stdin $CI_REGISTRY
  script:
    - docker build --no-cache --pull --tag "$CI_REGISTRY_IMAGE:$CI_PIPELINE_IID" .
    - docker push "$CI_REGISTRY_IMAGE:$CI_PIPELINE_IID"

contracttests:
  services:
    - name: $CI_REGISTRY_IMAGE:$CI_PIPELINE_IID
      alias: Producer
  stage: contract-tests
  image:
    name: postman/newman_alpine33
    entrypoint: [""]
  script:
    - newman --version
    - export NODE_PATH=$(npm root --quiet -g)
    - echo $NODE_PATH
    - node CustomerTests.js



